Summary:       A library for manipulating block devices
Name:          libblockdev
Version:       3.0.2
Release:       3%{?dist}
License:       LGPLv2+
URL:           https://github.com/storaged-project/libblockdev
Source0:       %{url}/releases/download/%{version}-%{release}/%{name}-%{version}.tar.gz

BuildRequires: make
BuildRequires: glib2-devel gobject-introspection-devel python3-devel glib2-doc autoconf-archive
Provides:      libblockdev-kbd = %{version}-%{release}
Provides:      libblockdev-kbd-devel = %{version}-%{release}
Obsoletes:     libblockdev-kbd < %{version}-%{release}
Obsoletes:     libblockdev-kbd-devel < %{version}-%{release}
Requires:      %{name}-utils = %{version}-%{release}

%description
The libblockdev is a C library supporting GObject introspection for manipulation
of block devices. It has a plugin-based architecture where each technology (like
LVM, Btrfs, MD RAID, Swap,...) is implemented in a separate plugin, possibly with
multiple implementations (e.g. using LVM CLI or the new LVM DBus API).

%package devel
Summary:  Development files for libblockdev
Requires: %{name} = %{version}-%{release}
Requires: %{name}-utils-devel = %{version}-%{release}
Requires: glib2-devel

%description devel
This package contains header files and pkg-config files needed for development
with the libblockdev library.


%package -n python3-blockdev
Summary:  Python3 gobject-introspection bindings for libblockdev
Requires: %{name} = %{version}-%{release}
Requires: python3-gobject-base python3-bytesize

%description -n python3-blockdev
This package contains enhancements to the gobject-introspection bindings for
libblockdev in Python3.


%package utils
Summary:       A library with utility functions for the libblockdev library
BuildRequires: kmod-devel

%description utils
The libblockdev-utils is a library providing utility functions used by the
libblockdev library and its plugins.


%package utils-devel
Summary:  Development files for libblockdev-utils
Requires: %{name}-utils = %{version}-%{release}
Requires: glib2-devel

%description utils-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-utils library.

%package crypto
Summary:       The crypto plugin for the libblockdev library
BuildRequires: cryptsetup-devel libblkid-devel nss-devel
BuildRequires: volume_key-devel >= 0.3.9-7
Requires:      %{name}-utils = %{version}-%{release}

%description crypto
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to encrypted devices (LUKS).


%package crypto-devel
Summary:  Development files for the libblockdev-crypto plugin/library
Requires: %{name}-crypto = %{version}-%{release}
Requires: glib2-devel
Requires: %{name}-utils-devel = %{version}-%{release}

%description crypto-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-crypto plugin/library.


%package dm
Summary:       The Device Mapper plugin for the libblockdev library
BuildRequires: device-mapper-devel systemd-devel
Requires:      %{name}-utils >= 0.11
Requires:      device-mapper

%description dm
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to Device Mapper.


%package dm-devel
Summary:  Development files for the libblockdev-dm plugin/library
Requires: %{name}-dm = %{version}-%{release}
Requires: glib2-devel device-mapper-devel systemd-devel
Requires: %{name}-utils-devel

%description dm-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-dm plugin/library.


%package fs
Summary:       The FS plugin for the libblockdev library
BuildRequires: parted-devel libblkid-devel libmount-devel libuuid-devel e2fsprogs-devel
Requires:      %{name}-utils >= 0.11

%description fs
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to operations with file systems.


%package fs-devel
Summary:  Development files for the libblockdev-fs plugin/library
Requires: %{name}-fs = %{version}-%{release}
Requires: %{name}-utils-devel
Requires: glib2-devel

%description fs-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-fs plugin/library.


%package loop
Summary:  The loop plugin for the libblockdev library
Requires: %{name}-utils >= 0.11

%description loop
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to loop devices.


%package loop-devel
Summary:  Development files for the libblockdev-loop plugin/library
Requires: %{name}-loop = %{version}-%{release}
Requires: %{name}-utils-devel
Requires: glib2-devel

%description loop-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-loop plugin/library.


%package lvm
Summary:       The LVM plugin for the libblockdev library
BuildRequires: device-mapper-devel
Requires:      %{name}-utils >= 0.11
Requires:      lvm2

%description lvm
The libblockdev library plugin (and in the same time a standalone library)
providing the LVM-related functionality.


%package lvm-devel
Summary:  Development files for the libblockdev-lvm plugin/library
Requires: %{name}-lvm = %{version}-%{release}
Requires: %{name}-utils-devel = %{version}-%{release}
Requires: glib2-devel

%description lvm-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-lvm plugin/library.


%package lvm-dbus
Summary:       The LVM plugin for the libblockdev library
BuildRequires: device-mapper-devel
Requires:      %{name}-utils >= 1.4
Requires:      lvm2-dbusd >= 2.02.156

%description lvm-dbus
The libblockdev library plugin (and in the same time a standalone library)
providing the LVM-related functionality utilizing the LVM DBus API.


%package lvm-dbus-devel
Summary:  Development files for the libblockdev-lvm-dbus plugin/library
Requires: %{name}-lvm-dbus = %{version}-%{release}
Requires: %{name}-utils-devel = %{version}-%{release}
Requires: glib2-devel

%description lvm-dbus-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-lvm-dbus plugin/library.


%package mdraid
Summary:       The MD RAID plugin for the libblockdev library
BuildRequires: libbytesize-devel
Requires:      %{name}-utils >= 0.11
Requires:      mdadm

%description mdraid
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to MD RAID.


%package mdraid-devel
Summary:  Development files for the libblockdev-mdraid plugin/library
Requires: %{name}-mdraid = %{version}-%{release}
Requires: %{name}-utils-devel
Requires: glib2-devel

%description mdraid-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-mdraid plugin/library.


%package mpath
Summary:       The multipath plugin for the libblockdev library
BuildRequires: device-mapper-devel
Requires:      %{name}-utils >= 0.11
Recommends:    device-mapper-multipath

%description mpath
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to multipath devices.


%package mpath-devel
Summary:  Development files for the libblockdev-mpath plugin/library
Requires: %{name}-mpath = %{version}-%{release}
Requires: %{name}-utils-devel
Requires: glib2-devel

%description mpath-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-mpath plugin/library.


%package nvdimm
Summary:       The NVDIMM plugin for the libblockdev library
BuildRequires: ndctl-devel libuuid-devel
Requires:      %{name}-utils >= 0.11
Requires:      ndctl

%description nvdimm
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to operations with NVDIMM devices.


%package nvdimm-devel
Summary:  Development files for the libblockdev-nvdimm plugin/library
Requires: %{name}-nvdimm = %{version}-%{release}
Requires: %{name}-utils-devel
Requires: glib2-devel

%description nvdimm-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-nvdimm plugin/library.


%package nvme
Summary:       The NVMe plugin for the libblockdev library
BuildRequires: libnvme-devel
BuildRequires: libuuid-devel
Requires:      %{name}-utils = %{version}-%{release}

%description nvme
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to operations with NVMe devices.

%package nvme-devel
Summary:  Development files for the libblockdev-nvme plugin/library
Requires: %{name}-nvme = %{version}-%{release}
Requires: %{name}-utils-devel = %{version}-%{release}
Requires: glib2-devel

%description nvme-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-nvme plugin/library.

%package part
Summary:       The partitioning plugin for the libblockdev library
BuildRequires: libfdisk-devel
Requires:      %{name}-utils >= 0.11
Requires:      util-linux

%description part
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to partitioning.


%package part-devel
Summary:  Development files for the libblockdev-part plugin/library
Requires: %{name}-part = %{version}-%{release}
Requires: %{name}-utils-devel
Requires: glib2-devel

%description part-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-part plugin/library.


%package swap
Summary:       The swap plugin for the libblockdev library
BuildRequires: libblkid-devel
Requires:      %{name}-utils >= 0.11
Requires:      util-linux

%description swap
The libblockdev library plugin (and in the same time a standalone library)
providing the functionality related to swap devices.


%package swap-devel
Summary:  Development files for the libblockdev-swap plugin/library
Requires: %{name}-swap = %{version}-%{release}
Requires: %{name}-utils-devel
Requires: glib2-devel

%description swap-devel
This package contains header files and pkg-config files needed for development
with the libblockdev-swap plugin/library.


%package tools
Summary:       Various nice tools based on libblockdev
Requires:      %{name}
Requires:      %{name}-lvm
BuildRequires: libbytesize-devel
Recommends:    %{name}-lvm-dbus

%description tools
Various nice storage-related tools based on libblockdev.


%package plugins-all
Summary:  Meta-package that pulls all the libblockdev plugins as dependencies
Requires: %{name} = %{version}-%{release}
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-dm = %{version}-%{release}
Requires: %{name}-fs = %{version}-%{release}
Requires: %{name}-loop = %{version}-%{release}
Requires: %{name}-lvm = %{version}-%{release}
Requires: %{name}-mdraid = %{version}-%{release}
Requires: %{name}-mpath = %{version}-%{release}
Requires: %{name}-nvdimm = %{version}-%{release}
Requires: %{name}-nvme = %{version}-%{release}
Requires: %{name}-part = %{version}-%{release}
Requires: %{name}-swap = %{version}-%{release}

%description plugins-all
A meta-package that pulls all the libblockdev plugins as dependencies.

%prep
%autosetup

%build
autoreconf -fiv
%configure --without-bcache \
           --without-btrfs \
           --without-dmraid \
           --without-vdo
%make_build

%install
%make_install
find %{buildroot} -type f -name "*.la" -exec rm -f {} ';'


	
%post  -p /sbin/ldconfig

%postun  -p /sbin/ldconfig

%post utils -p /sbin/ldconfig

%postun utils -p /sbin/ldconfig

%post crypto -p /sbin/ldconfig

%postun crypto -p /sbin/ldconfig

%post dm -p /sbin/ldconfig

%postun dm -p /sbin/ldconfig

%post fs -p /sbin/ldconfig

%postun fs -p /sbin/ldconfig

%post loop -p /sbin/ldconfig

%postun loop -p /sbin/ldconfig

%post lvm -p /sbin/ldconfig

%postun lvm -p /sbin/ldconfig

%post lvm-dbus -p /sbin/ldconfig

%postun lvm-dbus -p /sbin/ldconfig

%post mdraid -p /sbin/ldconfig

%postun mdraid -p /sbin/ldconfig

%post mpath -p /sbin/ldconfig

%postun mpath -p /sbin/ldconfig

%post nvdimm -p /sbin/ldconfig

%postun nvdimm -p /sbin/ldconfig

%post nvme -p /sbin/ldconfig

%postun nvme -p /sbin/ldconfig

%post part -p /sbin/ldconfig

%postun part -p /sbin/ldconfig

%post swap -p /sbin/ldconfig

%postun swap -p /sbin/ldconfig



%files
%license LICENSE
%{_libdir}/libblockdev.so.*
%{_libdir}/girepository*/BlockDev*.typelib
%dir %{_sysconfdir}/libblockdev
%dir %{_sysconfdir}/libblockdev/3/conf.d
%config %{_sysconfdir}/libblockdev/3/conf.d/00-default.cfg

%files devel
%{_libdir}/libblockdev.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/blockdev.h
%{_includedir}/blockdev/plugins.h
%{_libdir}/pkgconfig/blockdev.pc
%{_datadir}/gir*/BlockDev*.gir

%files -n python3-blockdev
%{python3_sitearch}/gi/overrides/BlockDev*
%{python3_sitearch}/gi/overrides/__pycache__/BlockDev*

%files utils
%{_libdir}/libbd_utils.so.*

%files utils-devel
%{_libdir}/libbd_utils.so
%{_libdir}/pkgconfig/blockdev-utils.pc
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/utils.h
%{_includedir}/blockdev/sizes.h
%{_includedir}/blockdev/exec.h
%{_includedir}/blockdev/extra_arg.h
%{_includedir}/blockdev/dev_utils.h
%{_includedir}/blockdev/module.h
%{_includedir}/blockdev/dbus.h
%{_includedir}/blockdev/logging.h

%files crypto
%{_libdir}/libbd_crypto.so.*

%files crypto-devel
%{_libdir}/libbd_crypto.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/crypto.h

%files dm
%{_libdir}/libbd_dm.so.*

%files dm-devel
%{_libdir}/libbd_dm.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/dm.h

%files fs
%{_libdir}/libbd_fs.so.*

%files fs-devel
%{_libdir}/libbd_fs.so
%dir %{_includedir}/blockdev
%dir %{_includedir}/blockdev/fs
%{_includedir}/blockdev/fs.h
%{_includedir}/blockdev/fs/*.h

%files loop
%{_libdir}/libbd_loop.so.*

%files loop-devel
%{_libdir}/libbd_loop.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/loop.h

%files lvm
%{_libdir}/libbd_lvm.so.*

%files lvm-devel
%{_libdir}/libbd_lvm.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/lvm.h

%files lvm-dbus
%{_libdir}/libbd_lvm-dbus.so.*
%config %{_sysconfdir}/libblockdev/3/conf.d/10-lvm-dbus.cfg

%files lvm-dbus-devel
%{_libdir}/libbd_lvm-dbus.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/lvm.h

%files mdraid
%{_libdir}/libbd_mdraid.so.*

%files mdraid-devel
%{_libdir}/libbd_mdraid.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/mdraid.h

%files mpath
%{_libdir}/libbd_mpath.so.*

%files mpath-devel
%{_libdir}/libbd_mpath.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/mpath.h

%files nvdimm
%{_libdir}/libbd_nvdimm.so.*

%files nvdimm-devel
%{_libdir}/libbd_nvdimm.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/nvdimm.h

%files nvme
%{_libdir}/libbd_nvme.so.*

%files nvme-devel
%{_libdir}/libbd_nvme.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/nvme.h

%files part
%{_libdir}/libbd_part.so.*

%files part-devel
%{_libdir}/libbd_part.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/part.h

%files swap
%{_libdir}/libbd_swap.so.*

%files swap-devel
%{_libdir}/libbd_swap.so
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/swap.h

%files tools
%{_bindir}/lvm-cache-stats
%{_bindir}/vfat-resize

%files plugins-all

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.2-3
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 22 2023 Shuo Wang <abushwang@tencent.com> - 3.0.2-2
- Rebuilt for ndctl 78

* Mon Aug 21 2023 Miaojun Dong <zoedong@tencent.com> - 3.0.2-1
- Bump version to 3.0.2

* Thu Aug 17 2023 Miaojun Dong <zoedong@tencent.com> - 2.28-2
- Rebuild for parted-3.6

* Wed Jul 12 2023 Miaojun Dong <zoedong@tencent.com> - 2.28-1
- Bump version to 2.28

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.27-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.27-3
- Rebuilt for OpenCloudOS Stream 23

* Thu Nov 17 2022 Zhao Zhen <jeremiazhao@tencent.com> - 2.27-2
- added ldconfig

* Fri Sep 02 2022 ZoeDong <zoedong@tencent.com> - 2.27-1
- Initial build
